<?php

namespace Drupal\email_content_templates\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\email_content_templates\Entity\EmailContentTemplateInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\Request;

class PreviewController extends ControllerBase {

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    $instance = new static();

    $instance->emailInfoManager = $container->get('plugin.manager.ect_mail');
    $instance->emailContentTemplatesService = $container->get('email_content_templates.service');
    return $instance;
  }

  public function preview(EmailContentTemplateInterface $email_content_template, Request $request) {
    $template = $this->entityTypeManager()->getStorage('email_content_template')
      ->load($request->get('template_id'));
    $email_plugin = $this->emailInfoManager->createInstance($template->getEmailPluginId());
    $token_map = $email_plugin->paramTokenMap();
    $params = ['template' => $template];
    foreach ($token_map as $param_name => $entity_type) {
      $entity_id = $request->get($param_name);
      if (!empty($entity_id)) {
        $entity = $this->entityTypeManager()->getStorage($entity_type)
          ->load($entity_id);
        $params[$param_name] = $entity;
      }
    }

    $message = [];
    $this->emailContentTemplatesService->prepareMessage($message, $params, $template);


    return ['#markup' => $message['body'][0]];
  }

}
